#include "serialClient.hpp"

int8_t readSerial() {
  uint16_t len = Serial.available();
  uint8_t buf[6];
 	
  wdt_reset();

  if(len < N_ROWS*N_COLS+1) {
    return -1;
  }
  
  Serial.readBytes(buf, 1);
  if(buf[0] != 'A') {
    if(buf[0] == 'C') {
    Serial.readBytes(buf, 6);
    if(memcmp(buf, "ONFIG:", 6) == 0) {
      len = Serial.readBytesUntil(',', config.ssid, sizeof(config.ssid)-1);
      config.ssid[len] = '\0';
      len = Serial.readBytesUntil(',', config.pass, sizeof(config.pass)-1);
      config.pass[len] = '\0';
      len = Serial.readBytesUntil(',', config.host, sizeof(config.host)-1);
      config.host[len] = '\0';
      config.port = Serial.parseInt();
      if(config.port > 0) {
        wdt_reset();
        config_save();
        printf("Config saved.\n");
        delay(100);
        asm volatile ("  jmp 0");
        return 0;
      } else {
        return 3;
      }
    } else {
      return 2;
    }

    } else {
      printf("A\n");
      return 1;
    }

  }

  len = Serial.readBytes(matrix.bytes, N_ROWS*N_COLS);
  sprintf((char*)buf, "%d\n", len);
  Serial.write(buf, 3);

  return 0;
}